#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2e3 + 10;
int blocked[MAXN][MAXN], prefix_ld[MAXN][MAXN], prefix_lu[MAXN][MAXN], prefix_rd[MAXN][MAXN], prefix_ru[MAXN][MAXN];

bool check(int i, int j, int k) {
    if (prefix_lu[i][j - k] - prefix_lu[i - k][j] + blocked[i - k][j] > 0) return 0;
    if (prefix_ld[i + k][j] - prefix_ld[i][j - k] + blocked[i][j - k] > 0) return 0;
    if (prefix_ru[i][j + k] - prefix_ru[i - k][j] + blocked[i - k][j] > 0) return 0;
    if (prefix_rd[i + k][j] - prefix_rd[i][j + k] + blocked[i][j + k] > 0) return 0;

    return 1;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            char ds;
            cin >> ds;

            blocked[i][j] = ds == '*';
        }
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            prefix_ld[i][j] = prefix_ld[i - 1][j - 1] + blocked[i][j];
            prefix_ru[i][j] = prefix_ru[i - 1][j - 1] + blocked[i][j];
        }
    }

    for (int i = 1; i <= n; i++) {
        for (int j = m; j >= 1; j--) {
            prefix_lu[i][j] = prefix_lu[i - 1][j + 1] + blocked[i][j];
            prefix_rd[i][j] = prefix_rd[i - 1][j + 1] + blocked[i][j];
        }
    }

    long long ans = 0;

    for (int i = 1; i <= n; i++) {
        int k = -1;

        for (int j = 1; j <= m; j++) {
            while (i - (k + 1) >= 1 && i + (k + 1) <= n && j - (k + 1) >= 1 && j + (k + 1) <= m && check(i, j, k + 1)) {
                k++;
            }

            ans += (long long) (k + 1);

            k--;
            if (k < -1) k = -1;
        }
    }

    cout << ans << endl;
    return 0;

}
